package main

import (
	"flag"
	"log"
	"os"
	"os/signal"
	"syscall"
)

var executable string

func init() {
	var err error
	executable, err = os.Executable()
	if err != nil {
		log.Printf("error getting executable path: %s\n restart is a no-op", err)
	}
}

func main(){
	// Parse flags
	flag.Parse()

	defer func() {
		// Restart if needed
		if reExec {
			restart()
		}
	}()

	// Setup configuration stuff
	configSetup()
	// TODO: store setup

	// Web stuff
	webSetup()
	registerWebpage()
	registerAPI()
	runServer()

	signalChannel := make(chan os.Signal, 1)
	signal.Notify(signalChannel, syscall.SIGINT, syscall.SIGTERM, syscall.SIGHUP, os.Interrupt, os.Kill)
	go func() {
		// Cleanup on function return
		defer func() { cleanup(false) }()
		for {
			currentSignal := <-signalChannel
			switch currentSignal {
			case os.Interrupt:
				println()
				return
			default:
				return
			}
		}
	}()
}
